// Author : Pierre Vuillemin (2016)
// License : CECILL
mode(-1)
mprintf("\tBuilding macros\n")

function rgenlib(lib_name, src_path, target_path)
   warning('off')
   src_path    = pathconvert(fullpath(src_path), %t, %t)
   target_path = pathconvert(fullpath(target_path), %t, %t)
   recursive_build(target_path, src_path)
   execstr(lib_name + "=lib(''"+target_path+"'')")
   [macros,path] = libraryinfo(lib_name)
   save(target_path + "lib", lib_name)
   execstr(lib_name+"=resume("+lib_name+")")
   warning('on')
endfunction

function recursive_build(target_path, path)
   all_files      = findfiles(path)
   names_to_write = []
   for i = 1:size(all_files,1)
      fi        = all_files(i)
      file_path = path + filesep() + fi
      if isdir(file_path)
         if part(fi,1) ~="."
            recursive_build(target_path, file_path + filesep())
         end
      elseif regexp(fi,"/\.sci$/") ~= []
         function_name  = strsubst(fi, "/\.sci$/","","r")
         names_to_write = [names_to_write;function_name]
         clear nold // clearing nold so that it is always on the stack
         nold     = size(who("get"),"*")
         exec(file_path, -1)
         new      = who("get")
         new      = new(1:(size(new,"*")-nold-1))
         if new ~= []
            bin_file = target_path + function_name + ".bin"
            [u,ierr] = mopen(bin_file,"wb")
            execstr("save(u,"+strcat(new($:-1:1),",")+")")
            mclose(u)
         end
      end
   end
   names_file  = target_path  + "names"
   [fd, err]   = mopen(names_file,"a")
   mputl(names_to_write, fd)
   mclose(fd)
endfunction


current_path   = get_absolute_file_path("buildmacros.sce")
current_path   = pathconvert(current_path,%t,%t)
src_path       = current_path + "src"
target_path    = current_path + "build"
if ~isdir(target_path) then
   mkdir(target_path)
end
rgenlib(toolbox_name + "lib", src_path, target_path)
clear current_path rgenlib recursive_build src_path target_path
