// Author : Pierre Vuillemin (2016)
// License : CECILL
// TODO: créer des fonctions pour chaque solveur qui va faire des tests sur la classe du problème
// TODO: pour déterminer, s'il s'applique, s'il est spécifique, etc.
function out = sopi_listSolvers()
   out = list()
   // LP solvers
   // karmarkar
   out($+1) = sopi_newSolver("name", "karmarkar", "objClass", 1,"cstClass", [0,1], "requireX0", %F)
   if atomsIsLoaded('quapro')
      // linpro
      out($+1) = sopi_newSolver("name", "linpro", "objClass", 1, "cstClass", [0,1], "requireX0", %F)
   end
   // General solvers
   out($+1) = sopi_newSolver("name","optim","objClass",[1,42], "cstClass",[-1,0], "requireX0", %T)
   if atomsIsLoaded('fmincon') then
      out($+1) = sopi_newSolver("name","fmincon", "objClass",[1], "cstClass", [0,1,2], "requireX0", %T)
   end
   // Stochastic
   if atomsIsLoaded('CMA-ES') then
      out($+1) = sopi_newSolver("name", "cmaes","objClass", [1], "cstClass", -1, "requireX0", %T)
   end
endfunction


function solver = sopi_newSolver(varargin)
   objType  = "sopiSolver";
   objAtt   = list( "name"       , "",...
                    "objClass"   , [],...
                    "cstClass"   , [],...
                    "call"       , [],...
                    "requireX0", []);
   solver = sopi_makeObject(objType, objAtt);
   solver = sopi_fillList(solver, varargin)
   if ~isempty(solver.name) then
      solver.call = "sopi_" + solver.name
   end
endfunction
