// Author : Pierre Vuillemin (2016)
// License : CECILL

function out = %sopiCst_e(varargin)
   c = varargin($)
   if length(varargin) == 2 & typeof(varargin(1))=="string" then
      field = varargin(1)
      validFieldNames = fieldnames(c)
      if or(field == validFieldNames) then
         out = getfield(field, c)
      else
         possibleTests = ["depends","isLinear","isConvex"]
         if or(field == possibleTests)
            out = c.lhs(field)
         elseif field == "nvar"
            vars  = c.lhs.depends
            out   = 0
            for v = vars
               out = out + prod(v.size)
            end
         elseif field =="n"
            out = size(c.lhs,1)
         elseif field == "isBound"
            if c.isLinear 
               out = %F
               tmp = sopi_extractLinearPart(c.lhs)
               if length(tmp) == 1 then
                  L     = tmp(1)(1)
                  R     = tmp(1)(2)
                  F     = R' .*. L
                  v     = tmp(1)(3)
                  out   = size(v,2) == 1 & and(abs(F) == eye(length(F),length(F)))
               end
            else
               out = %F
            end
         end
      end
   else
      error('Invalid field for extraction')
   end
endfunction
