// Author : Pierre Vuillemin (2016)
// License : CECILL

function constraint = %sopiVar_3_s(var,maxVal)
   // Overloads sopiVar <= maxVal.
   //
   // Inputs
   // ------
   // var (sopiVar)
   // maxVal(float)
   //
   // Returns
   // -------
   // A sopiCst representing the constraint.
   //
   sopi_checkSizesCoherence(var,maxVal,"constraint")
   constraint        = sopi_newCst()
   constraint.lhs    = var - maxVal
   constraint.type   = "ineq"
   sopi_print(3,"Creating inequality constraint.\n")
endfunction
