// Author : Pierre Vuillemin (2016)
// License : CECILL

function fun = sopi_toScilabFunction(var,problem)
   data           = list()
   dep            = var.depends;
   nvar           = length(dep)
   //
   [funStr, data] = sopi_toScilabFunRec(var, "y=", list())
   // Head of the function
   funHead        = "y = innerSopiFun("
   if argn(2) < 2 then
      for i = 1:nvar
         funHead = funHead + "var_" + string(dep(i).id) + ','
      end      
   else
      funHead  = funHead + "x,"
      varDec   = ""
      for i = 1:nvar
         varName     = "var_" + string(dep(i).id)
         data($+1)   = sopi_getVarIdxInProblem(problem, dep(i))
         varDec      = varDec + varName + "= x(data("+string(length(data))+"));"
      end
      funStr = varDec + funStr
   end
   funHead        = strcat([funHead, "data)"])
   deff(funHead,funStr)
   fun            = sopi_lambdaFun(innerSopiFun, data)
endfunction

function [funStr, data] = sopi_toScilabFunRec(var, funStr, data)
   if var.isElementary
      funStr = strcat([funStr,"var_",string(var.id)])
   else
      select var.operator
      case "constant"
         data($+1)   = var.args(1)
         funStr      =  strcat([funStr, "data(",string(length(data)),")"])
      case "sum"
         [funStr, data] = sopi_toScilabFunRec(var.args(1), funStr, data)
         funStr         = strcat([funStr,"+"])
         [funStr, data] = sopi_toScilabFunRec(var.args(2), funStr, data)
      case "times"
         [funStr, data] = sopi_toScilabFunRec(var.args(1), funStr, data)
         funStr         = strcat([funStr, "*"])
         [funStr, data] = sopi_toScilabFunRec(var.args(2), funStr, data)
      case "abs"
         [funStr, data] = sopi_toScilabFunRec(var.args(1), funStr, data)
         funStr         = "abs(" + funStr +")"
      else
         error('nope')
      end
   end
endfunction
