// Author : Pierre Vuillemin (2016)
// License : CECILL

function out = %sopiPro_e(varargin)
   // Overloading of the extraction for a sopiPro
   //
   // Inputs
   // ------
   // 
   //
   // Returns
   // -------
   // The desired field or answer to the test.
   //
   p = varargin($)
   if length(varargin) == 2 & typeof(varargin(1)) == "string" then
      field             = varargin(1)
      validFieldNames   = fieldnames(p)
      if or(field == validFieldNames) then
         out = getfield(field, p)
      else
         out = sopi_performProTest(p,field)
      end
   else
      error("Invalid extraction")
   end
endfunction

function out = sopi_performProTest(p, test)
   select test
   case "nlec"
      out = size(p.Aeq,1)
   case "nlic"
      out = size(p.A,1)
   case "nnlec"
      out = length(p.ceq)
   case "nnlic"
      out = length(p.c)
   case "nlb"
      out = sum(p.lb > -%inf)
   case "nub"
      out = sum(p.ub < %inf)
   case "nc"
      out = p.nlec + p.nlic + p.nnlec + p.nnlic + p.nlb + p.nub
   end
endfunction
