// Author : Pierre Vuillemin (2016)
// License : CECILL

// abs .........................................................................
function newVar = %sopiVar_abs(var)
   if var.isConstant then
      newVar = sopi_constant(abs(var.args(1)))
   else
      newSize  = size(var)
      newVar   = sopi_newVar("size"    , newSize,...
                             "operator", "abs",...
                             "args", list(var))
      //
      P        = sopi_newMatProp(newSize)
      CONVEX   = "convex"
      PWA      = "pwa"
      linTerms = var.isLinear | var.isPWA
      for i = 1:newSize(1)
         for j = 1:newSize(2)
            if linTerms(i,j)
               P(i)(j).sets = [CONVEX, PWA]
            end
         end
      end
      newVar.prop = P
      //
      slackVar       = sopi_var(newSize)
      newVar.graph   = struct("constraints",slackVar >= var &  -slackVar <= - var,...
                              "slackVar", slackVar)
   end
endfunction
