// Author : Pierre Vuillemin (2016)
// License : CECILL

// power .......................................................................
function newVar = %sopiVar_p_s(var, pow)
   if ~var.isSquare then
      error("Power only for square variables");
   end
   if pow == 1 then
      newVar      = var;
   else
      powVar         = sopi_constant(pow);
      newVar         = sopi_newVar("size"    , size(var),...
                                   "operator", "pow",...
                                   "args"    , list(var,powVar))
      //
      newVar.prop    = sopi_powerRules(var.prop,pow)
   end
endfunction

//
function Pout = sopi_powerRules(P, pow)
   m     = size(P)
   n     = size(P(1))
   Pout  = sopi_newMatProp([m,n])
   for i = 1:m
      for j = 1:n
         Pout(i)(j) = sopi_elPowerRules(P(i)(j), pow)
      end
   end
endfunction

//
function pout = sopi_elPowerRules(p, pow)
   SETS     = "sets"
   CONVEX   = "convex"
   CONCAVE  = "concave"
   DIFF     = "diff"
   RAT      = "rat"
   PWA      = "PWA"   
   pout     = sopi_newProp()
   if p.isPoly | p.isRat then
      pout.sets         = [pout.sets;RAT]
      pout.data.norder  = p.data.norder*pow
      pout.data.dorder  = p.data.dorder * pow
   end
   if p.isLinear  & modulo(pow,2)==0 then
      pout.sets = [pout.sets; CONVEX]
   end
   if p.isDiff then
      pout.sets = [pout.sets; DIFF]
   end
endfunction
