// Author : Pierre Vuillemin (2016)
// License : CECILL

// sopiVar' ....................................................................
// transposes a sopiVar.
function newVar = %sopiVar_t(var)
   sopi_print(5,"Performing sopiVar''.\n");   
   if var.isScalar then
      newVar   = var;
   elseif var.operator == "transpose" then
      newVar   = var.args(1)
   else
      [m,n]    = size(var)
      newVar   = sopi_newVar("size"    , [n,m],...
                             "operator", "transpose",...
                             "args"    , list(var))
      prop     = sopi_newMatProp([n,m]) 
      for i = 1:n
         for j = 1:m
            prop(i)(j) = var.prop(j)(i)
         end
      end
      newVar.prop = prop
   end
endfunction
