// Author : Pierre Vuillemin (2016)
// License : CECILL

// sopi_constant ...............................................................
// creates a sopiVar representing a constant.
function constant = sopi_constant(b)
   constant             = sopi_newVar("size"       , size(b), ..
                                       "operator"  , "constant",...
                                       "args"      , list(b));
   belongsTo   = ["poly";"convex";"concave";"rat";"diff"]
   data        = struct("norder",0,"dorder",0)
   prop        = sopi_newMatProp(size(constant), "sets", belongsTo, "data", data) 
   si          = sign(b)
   for i = 1:size(b,1)
      for j = 1:size(b,2)
         prop(i)(j).data.sign = si(i,j)
      end
   end
   constant.prop = prop
endfunction
