// Author : Pierre Vuillemin (2016)
// License : CECILL

// sopi_newMatProp .............................................................
// creates a matrix of sopiProp that gathers the properties of each entries in 
// a matrix sopiVar.
function P = sopi_newMatProp(s, varargin)
   P = list()
   for i= 1:s(1)
      if size(P) < s(1)
         P($+1) = list()
      end
      for j = 1:s(2)
         if size(P(i)) < s(2)
            P(i)($+1)   = sopi_newProp(varargin(:))
         else
            P(i)(j)     = sopi_newProp(varargin(:))
         end
      end
   end
endfunction

// sopi_newProp ................................................................
// creates a new object sopiProp containing a set of properties for a scalar 
// variable. Properties can be convexity, concavity, etc.
function p = sopi_newProp(varargin)
   objType  = "sopiProp"
   objAtt   = list("sets",[],"data",struct())
   p        = sopi_makeObject(objType, objAtt)
   p        = sopi_fillList(p, varargin)
endfunction
