// Author : Pierre Vuillemin (2016)
// License : CECILL

// sopi_newVar ................................................................ 
// creates an empty sopiVar object.
function var = sopi_newVar(varargin)
   objType  = "sopiVar";
   objAtt   = list( "id"      , sopi_getNewId(),...
                    "size"    ,              [],...
                    "name"    ,              "",...
                    "operator",              "",...
                    "opt"     ,              [],...
                    "args"    ,              list(),...
                    "prop"    ,              [],...
                    "graph"   ,              struct());
   var         = sopi_makeObject(objType, objAtt);
   var         = sopi_fillList(var, varargin) // does not seem to be used
   if ~isempty(var.size) then
      var.prop = sopi_newMatProp(var.size)
   end
endfunction

// sopi_getNewId ...............................................................
// finds an id for a sopiVar.
function id = sopi_getNewId()
   global sopiData
   id               = sopiData.varId + 1;
   sopiData.varId   = id;
endfunction

