// Author : Pierre Vuillemin (2016)s
// License : CECILL

function sopi_end()
   // Clears all sopi-related variables.
   //
   // Calling Sequence
   // sopi_end()
   //
   // Description
   // Attempts to clean all sopi related variables and assign optimal values, if
   // any.
   //
   // Examples
   // // Initialisation of sopi
   // sopi_begin();
   // // Declaring a sopiVar
   // x = sopi_var(1);
   // disp(x);
   // // Cleaning sopiVars
   // sopi_end();
   // disp(exists(x));
   //
   clearglobal sopiData
   vars     = sopi_getExistingSopiVar()
   if ~isempty(vars) then
      data     = list()
      out      = []
      argStr   = []
      for i = 1:length(vars)
         var      = vars(i)(1)
         varName  = vars(i)(2)
         out      = [out, varName]
         if ~isempty(var.opt)
            data($+1)   = var.opt
            argStr      = [argStr, "data(" + string(length(data))+")"]
         else
            argStr = [argStr, "clear(''"+varName+"'')"]
         end
      end
      clear var
      exStr = "["+ strcat(out,",")+"] = resume(" + strcat(argStr,",")+");" 
      execstr(exStr)
   end
endfunction
