// Copyright 2016 - Pierre Vuillemin
// License : CECILL

function sopi_example(n)
   // Interface for loading examples for sopi.
   //
   // Calling Sequence
   // sopi_example()
   // sopi_example(n)
   //
   // Parameters
   // n : number of the example to load
   //
   // Description
   // With no argument, it displays the list of examples and their corresponding codes.
   // With an argument, it opens the corresponding example.
   //
   // Examples
   // sopi_example()    // list the available examples
   // sopi_example(1)   // load the first example
   if argn(2) < 1 then
      // displaying the list of examples
      titl     = "List of examples"
      headers  = list("Example","code")
      entries  = list("Simple LP", "1") 
      tab      = sopi_tabular(titl, headers, entries)
      mprintf(tab)      
   else
      // loading one example
      if atomsIsLoaded('sopi')
         src_path = SCIHOME + filesep() + "atoms"+ filesep() + "sopi" + filesep() + "demos" + filesep() + "sopi_demo_"
         select n
         case 1
            src_path = src_path + "simpleLP"
         else
            error(sprintf("Unknown example ''%d''",n))
         end
         src_path    = src_path + ".sce"
         target_path = TMPDIR + filesep() + "sopi_example.sce"
         copyfile(path, TMP)
         if (isdef("editor") | (funptr("editor") <> 0)) then
            editor(target_path);
         end         
      else
         error("Can only load examples when sopi is loaded as an atoms module.")
      end
   end
endfunction
