// Author : Pierre Vuillemin (2016)
// License : CECILL

// sopi_makeObject .............................................................
// is the unified interface for objects creation in sopi.
// It requires the type of the object (string) and its attributes together with
// their initial values represented as a list : 
// objAtt = list("attribute1",attribute1InitialValue,...)
function obj = sopi_makeObject(objType,objAtt)
   attributesList = list(objAtt(1:2:$));
   initialValues  = list(objAtt(2:2:$));
   // Convert list of attributes to array of attributes
   attributes     = [];
   for a = attributesList
      attributes = [attributes,a]
   end
   // Build the object
   obj            = mlist([objType,attributes])
   // Assign the initial values
   for i = 1:length(initialValues)
      field       = attributesList(i);
      obj(field)  = initialValues(i);
   end
endfunction
