// Author : Pierre Vuillemin (2016)
// License : CECILL
function out = sopi_tabular(titl, header, entries)
  ncol         = length(header)
  colLen       = zeros(ncol, 1)
  dispHeader   = %F
  for i = 1:ncol
    colLen(i) = length(header(i))
    if ~isempty(header(i))
       dispHeader = %T
    end
  end
  for i = 1:ncol:length(entries)
    for j = 1:ncol
      if typeof(entries(i + j - 1)) == 'constant' then 
        entries(i + j - 1) = sprintf('%d', entries(i + j - 1))
      end
      colLen(j) = max(colLen(j), length(entries(i + j - 1)))
    end
  end
  totalLen  = sum(colLen) + ncol * 2 + ncol + 2
  out= ""
  if dispHeader then
     out       = out + '+' + sopi_tiret(totalLen - 3) + '+\n'
     out       = out + "| "
     for i = 1:length(header)
        if i > 1
           out = out + " | "
        end
        if ~isempty(header(i))
           lentry = length(header(i))
           out    = out + header(i) + sopi_blanks(colLen(i)-lentry)
        else
           out = out + sopi_blanks(colLen(i))
        end
     end
     out    = out + " | \n"
  end
  out    = out + '+' + sopi_tiret(totalLen - 3) + '+\n'  
  for i = 1:ncol:length(entries)
    if entries(i) == 'Constraints' | entries(i) == "Available solvers" then 
      out = out + '+' + sopi_tiret(totalLen - 3) + '+\n'
    end
  
    out = out + '| '
    for j = 1:ncol
      lcol = length(entries(i + j - 1))
      if j > 1 then 
        colStr = ' | ' + sopi_blanks(colLen(j) - lcol) + entries(i + j - 1)
      else 
        colStr = entries(i + j - 1) + sopi_blanks(colLen(j) - lcol)
      end
      out = out + colStr
    end
    out = out + ' |\n'
    if entries(i) == 'Constraints' | entries(i) == "Available solvers" then 
      out = out + '+' + sopi_tiret(totalLen - 3) + '+\n'
    end
  end
  out = out + '+' + sopi_tiret(totalLen - 3) + '+\n'
endfunction

function out = sopi_blanks(n)
   out = ""
   for i = 1:n
      out = out + " "
   end
endfunction

function out = sopi_tiret(n)
   out = ""
   for i = 1:n
      out = out + "-"
   end
endfunction
