// Author : Pierre Vuillemin (2016)
// License : CECILL

mode(-1)
toolbox_name = "test"
function recursive_build(target_path, path)
   all_files = findfiles(path)
   names_to_write = []
   for i = 1:size(all_files,1)
      fi        = all_files(i)
      file_path = path + filesep() + fi
      if isdir(file_path)
         recursive_build(target_path, file_path + filesep())
      elseif regexp(fi,"/\.sci$/") <> []
         function_name  = strsubst(fi,".sci","")
         names_to_write = [names_to_write;function_name]
         exec(file_path, -1)
         save(target_path + function_name + ".bin", function_name)
      end
   end
   names_file = target_path  + "names"
   [fd, err] = mopen(names_file,"a")
   mputl(names_to_write, fd)
   mclose(fd)
endfunction

current_path   = get_absolute_file_path("build.sce")
current_path   = pathconvert(current_path,%t,%t)
target_path    = current_path +  "build" + filesep()
src_path       = current_path +  "src" + filesep()
recursive_build(target_path, src_path)
testlib        = lib(target_path)
clear src_path current_path target_path recursive_build
